import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Rectangle;

class ArcCanvas extends Canvas {
   int startAngle;
   int endAngle = 45;
   boolean filled = false;
   Font font;

   public void paint(Graphics g) {
      Rectangle r = ((Component)this).bounds();
      int hlines = r.height / 10;
      int vlines = r.width / 10;
      g.setColor(Color.pink);

      for(int i = 1; i <= hlines; ++i) {
         g.drawLine(0, i * 10, r.width, i * 10);
      }

      for(int i = 1; i <= vlines; ++i) {
         g.drawLine(i * 10, 0, i * 10, r.height);
      }

      g.setColor(Color.red);
      if (this.filled) {
         g.fillArc(0, 0, r.width - 1, r.height - 1, this.startAngle, this.endAngle);
      } else {
         g.drawArc(0, 0, r.width - 1, r.height - 1, this.startAngle, this.endAngle);
      }

      g.setColor(Color.black);
      g.setFont(this.font);
      g.drawLine(0, r.height / 2, r.width, r.height / 2);
      g.drawLine(r.width / 2, 0, r.width / 2, r.height);
      g.drawLine(0, 0, r.width, r.height);
      g.drawLine(r.width, 0, 0, r.height);
      int sx = 10;
      int sy = r.height - 28;
      g.drawString("S = " + this.startAngle, sx, sy);
      g.drawString("E = " + this.endAngle, sx, sy + 14);
   }

   public void redraw(boolean filled, int start, int end) {
      this.filled = filled;
      this.startAngle = start;
      this.endAngle = end;
      ((Component)this).repaint();
   }

   public ArcCanvas() {
   }
}
